# $Id: common.mk,v 1.7 2002/11/21 11:52:52 ott Exp $

PLTCOLLECTS = /usr/local/dozor/lib/plt/collects
MZS_ARCH    = i386-linux
BINDIR  = /usr/local/dozor/bin

MZS_DYNLOAD = $(PLTCOLLECTS)/mzscheme/lib/$(MZS_ARCH)/mzdyn.o
MZS_INCDIR  = $(PLTCOLLECTS)/mzscheme/include
MZS_LIBDIR  = $(PLTCOLLECTS)/mzscheme/lib/$(MZS_ARCH)
MZS_LIB     = mzscheme

# standart C++ & C compilers
CPPC = g++
CC   = gcc
# how to install files
INSTALL=cp

CURINCDIR= .

#DEBUG = 1

ifdef DEBUG
MKFLAGS += DEBUG=$(DEBUG)
endif

CURRENT_DIR = $(shell pwd)

OSTYPE := $(shell uname)

STD_DEFS =
ALL_DEFS = $(DEFS) $(HOST_DEFS) $(STD_DEFS)

STD_INCDIR =
ALL_INCDIR = $(INCDIR) $(STD_INCDIR) $(MZS_INCDIR) $(CURINCDIR)

ifdef DEBUG
CPPFLAGS += -ggdb -Wall -D__TRACE -D__DEBUG
else
CPPFLAGS += -Wall
endif

ifeq ($(OSTYPE),SunOS)
SHARED_FLAG = -G
CPPFLAGS += -fpic
else
SHARED_FLAG = -shared -fPIC
CPPFLAGS += -fPIC
endif
ifeq ($(OSTYPE),HP-UX)
CPPFLAGS += -D_XOPEN_SOURCE_EXTENDED
endif

INC_CPPFLAGS = $(ALL_INCDIR:%=-I%)
DEF_CPPFLAGS = $(ALL_DEFS:%=-D%)

ALL_CPPFLAGS = $(CPPFLAGS) $(INC_CPPFLAGS) $(DEF_CPPFLAGS) $(HOST_CPPFLAGS)

ALL_CFLAGS = $(ALL_CPPFLAGS)

STD_LIBDIRS = 
ALL_LIBDIRS = $(LIBDIRS) $(HOST_LIBDIRS) $(STD_LIBDIRS) $(MZS_LIBDIR)

ifdef EFENCE
LIBS += efence
endif

STD_LIBS =
ALL_LIBS = $(LIBS) $(HOST_LIBS) $(SYS_LIBS) $(STD_LIBS) 

STD_LINKFLAGS =
LIB_LINKFLAGS = $(ALL_LIBS:%=-l%)
DIR_LINKFLAGS = $(ALL_LIBDIRS:%=-L%)

ALL_LINKFLAGS = $(LINKFLAGS) $(LIB_LINKFLAGS) $(DIR_LINKFLAGS) $(HOST_LINKFLAGS) $(STD_LINKFLAGS)

VPATH = $(ALL_INCDIR) $(ALL_LIBDIRS)

COLLECTION ?= local


install-scm:
	mkdir -p $(PLTCOLLECTS)/$(COLLECTION)
	for i in $(SCM_LIBS); do \
	  cp $$i $(PLTCOLLECTS)/$(COLLECTION)/$$i ; \
	  chmod 0644 $(PLTCOLLECTS)/$(COLLECTION)/$$i ; \
	done

install-ext:
	mkdir -p $(PLTCOLLECTS)/extensions
	for i in $(EXTENSIONS); do \
	  cp $$i $(PLTCOLLECTS)/extensions/$$i ; \
	  chmod 0755 $(PLTCOLLECTS)/extensions/$$i ; \
	done

install-bin:
	mkdir -p $(BINDIR)
	for i in $(PROGRAMM); do \
	  cp $$i $(BINDIR)/$$i ; \
	  chmod 0755 $(BINDIR)/$$i ; \
	done

test: all
	for i in $(TESTPROGRAMS); do \
	  $(BINDIR)/mzscheme -r $$i ; \
	done 

clean :
#	echo "OSTYPE=$(OSTYPE)"
	-rm -f *.o *.so *~ core

%.so : %.o
	$(CC) $^ $(ALL_CFLAGS) $(SHARED_FLAG) $(ALL_LINKFLAGS) $(MZS_DYNLOAD) -o $@ 


%.o : %.cpp
	$(CPPC) -c $< $(ALL_CPPFLAGS) -o $@

%.o : %.cxx
	$(CPPC) -c $< $(ALL_CPPFLAGS) -o $@

%.o : %.c
	$(CC) -c $< $(ALL_CFLAGS) -o $@

