#!/usr/local/dozor/bin/mzscheme -r

;; File: mzgdbm-tests.scm
;; Created: 16 Dec 2002 by Alex Ott <ott@jet.msk.su>
;;


(require-library "assert.ss" "schemeunit")
(require-library "test.ss" "schemeunit")
(require-library "text-ui.ss" "schemeunit")

(load "mzgdbm.scm")

(define gdbm #f)
(define test-key "test1-key")
(define test-value "test1-value")

(define gdbm-tests
  (make-test-suite
   "GDBM tests"
   (make-test-case "open gdbm file" 
		   (assert-true (gdbm:file? (let ((lgdbm (gdbm:open "test.db" :gdbm:write-create)))
                                             (set! gdbm lgdbm)
                                             lgdbm))))
   (make-test-case "store gdbm record"
                   (assert-pred void? (gdbm:store gdbm test-key test-value)))
   (make-test-case "gdbm record exists?"
                   (assert-true (gdbm:exists? gdbm test-key)))
   (make-test-case "store/read equal?" (assert-equal?
                                        (gdbm:fetch gdbm test-key)
                                        test-value
                                        ))
   (make-test-case "fetching first key from gdbm"
                   (assert-pred (lambda (x)
                                  (if x
                                      #t
                                      #f))
                                (gdbm:first-key gdbm)))
   (make-test-case "fetching first pair from gdbm"
                   (assert-pred (lambda (x)
                                  (not (null? x)))
                                (gdbm:first-pair gdbm)))
   (make-test-case "delete gdbm record"
                   (assert-pred void? (gdbm:delete gdbm test-key)))
   (make-test-case "gdbm file descriptor valid?"
                   (assert >= (gdbm:file-descriptor gdbm) 0))
   ))

(test/text-ui
 gdbm-tests
 )





